
#include <iostream>

using namespace std;

int dx[4] = {1,0,-1,0};
int dy[4] = {0,1,0,-1};

char t[3][3], f[3][3], s[3][3];
char g[3][3];
void rot(int cx,int cy,int nx,int ny){
	if(cx == nx){
		swap(t[cy][cx], f[ny][nx]);
		swap(f[cy][cx], t[ny][nx]);
		swap(s[cy][cx], s[ny][nx]);
	}else{
		swap(t[cy][cx], s[ny][nx]);
		swap(s[cy][cx], t[ny][nx]);
		swap(f[cy][cx], f[ny][nx]);
	}
}
void dfs(int cx, int cy, int unmatch, int turn, int px, int py, int &ans){
	if(unmatch == 0){
		ans = turn;
		return;
	}
	if(turn + unmatch - 1 >= ans) return;
	for(int w=0;w<4;w++){
		int nx = cx + dx[w];
		int ny = cy + dy[w];
		if(nx < 0 || ny < 0 || nx >= 3 || ny >= 3) continue;
		if(nx == px && ny == py) continue;
		int cur_p  = (t[cy][cx] != g[cy][cx])+(t[ny][nx] != g[ny][nx]);
		rot(cx, cy, nx, ny);
		int next_p = (t[cy][cx] != g[cy][cx])+(t[ny][nx] != g[ny][nx]);
		dfs(nx, ny, unmatch -cur_p + next_p, turn+1, cx, cy, ans);
		rot(nx, ny, cx, cy);
	}
}

int solve(int x,int y){
	t[y][x] = f[y][x] = s[y][x] = 'E';
	int unmatch = 0;
	for(int i=0;i<3;i++)
		for(int j=0;j<3;j++)
			unmatch+= g[i][j] != t[i][j];
	int ans = 31;
	dfs(x,y,unmatch, 0, -1, -1, ans);
	return (ans > 30?-1:ans);
}
int main(void){
	while(true){
		int x,y;
		cin >> x >> y;
		if(!(x|y)) break;
		x--; y--;
		for(int i=0;i<3;i++)
			for(int j=0;j<3;j++)
				cin >> g[i][j];
		memset(t, 'W', sizeof(t));
		memset(f, 'R', sizeof(f));
		memset(s, 'B', sizeof(s));
		cout << solve(x,y) << endl;
	}
}
